diff -urN Original_4.4.4_r1/frameworks/base/media/java/android/media/MediaPlayer.java AndroidSource/frameworks/base/media/java/android/media/MediaPlayer.java
--- Original_4.4.4_r1/frameworks/base/media/java/android/media/MediaPlayer.java	2016-01-29 15:12:31.439488000 +0900
+++ AndroidSource/frameworks/base/media/java/android/media/MediaPlayer.java	2016-09-26 18:37:06.839666097 +0900
@@ -573,20 +634,27 @@
     private final static String IMEDIA_PLAYER = "android.media.IMediaPlayer";
 
     private int mNativeContext; // accessed by native methods
-    private int mNativeSurfaceTexture;  // accessed by native methods
+    private int mNativeSurfaceTexture; // accessed by native methods
     private int mListenerContext; // accessed by native methods
     private SurfaceHolder mSurfaceHolder;
     private EventHandler mEventHandler;
     private PowerManager.WakeLock mWakeLock = null;
     private boolean mScreenOnWhilePlaying;
     private boolean mStayAwake;
+    private boolean isAudio = false;
+    private Uri mContent;
+    public Context mContext;
+    public MediaExtractor mMediaExtractor;
+    
 
     /**
      * Default constructor. Consider using one of the create() methods for
      * synchronously instantiating a MediaPlayer from a Uri or resource.
-     * <p>When done with the MediaPlayer, you should call  {@link #release()},
-     * to free the resources. If not released, too many MediaPlayer instances may
-     * result in an exception.</p>
+     * <p>
+     * When done with the MediaPlayer, you should call {@link #release()}, to
+     * free the resources. If not released, too many MediaPlayer instances may
+     * result in an exception.
+     * </p>
      */
     public MediaPlayer() {
 
@@ -604,19 +672,21 @@
         mOpenSubtitleSources = new Vector<InputStream>();
         mInbandSubtitleTracks = new SubtitleTrack[0];
 
-        /* Native setup requires a weak reference to our object.
-         * It's easier to create it here than in C++.
+        /*
+         * Native setup requires a weak reference to our object. It's easier to
+         * create it here than in C++.
          */
         native_setup(new WeakReference<MediaPlayer>(this));
     }
 
     /*
-     * Update the MediaPlayer SurfaceTexture.
-     * Call after setting a new display surface.
+     * Update the MediaPlayer SurfaceTexture. Call after setting a new display
+     * surface.
      */
     private native void _setVideoSurface(Surface surface);
 
-    /* Do not change these values (starting with INVOKE_ID) without updating
+    /*
+     * Do not change these values (starting with INVOKE_ID) without updating
      * their counterparts in include/media/mediaplayer.h!
      */
     private static final int INVOKE_ID_GET_TRACK_INFO = 1;
@@ -627,15 +697,13 @@
     private static final int INVOKE_ID_SET_VIDEO_SCALE_MODE = 6;
 
     /**
-     * Create a request parcel which can be routed to the native media
-     * player using {@link #invoke(Parcel, Parcel)}. The Parcel
-     * returned has the proper InterfaceToken set. The caller should
-     * not overwrite that token, i.e it can only append data to the
-     * Parcel.
-     *
-     * @return A parcel suitable to hold a request for the native
-     * player.
-     * {@hide}
+     * Create a request parcel which can be routed to the native media player
+     * using {@link #invoke(Parcel, Parcel)}. The Parcel returned has the proper
+     * InterfaceToken set. The caller should not overwrite that token, i.e it
+     * can only append data to the Parcel.
+     * 
+     * @return A parcel suitable to hold a request for the native player.
+     *         {@hide}
      */
     public Parcel newRequest() {
         Parcel parcel = Parcel.obtain();
@@ -644,18 +712,15 @@
     }
 
     /**
-     * Invoke a generic method on the native player using opaque
-     * parcels for the request and reply. Both payloads' format is a
-     * convention between the java caller and the native player.
-     * Must be called after setDataSource to make sure a native player
-     * exists. On failure, a RuntimeException is thrown.
-     *
-     * @param request Parcel with the data for the extension. The
-     * caller must use {@link #newRequest()} to get one.
-     *
-     * @param reply Output parcel with the data returned by the
-     * native player.
-     * {@hide}
+     * Invoke a generic method on the native player using opaque parcels for the
+     * request and reply. Both payloads' format is a convention between the java
+     * caller and the native player. Must be called after setDataSource to make
+     * sure a native player exists. On failure, a RuntimeException is thrown.
+     * 
+     * @param request Parcel with the data for the extension. The caller must
+     *            use {@link #newRequest()} to get one.
+     * @param reply Output parcel with the data returned by the native player.
+     *            {@hide}
      */
     public void invoke(Parcel request, Parcel reply) {
         int retcode = native_invoke(request, reply);
@@ -666,15 +731,13 @@
     }
 
     /**
-     * Sets the {@link SurfaceHolder} to use for displaying the video
-     * portion of the media.
-     *
-     * Either a surface holder or surface must be set if a display or video sink
-     * is needed.  Not calling this method or {@link #setSurface(Surface)}
-     * when playing back a video will result in only the audio track being played.
-     * A null surface holder or surface will result in only the audio track being
-     * played.
-     *
+     * Sets the {@link SurfaceHolder} to use for displaying the video portion of
+     * the media. Either a surface holder or surface must be set if a display or
+     * video sink is needed. Not calling this method or
+     * {@link #setSurface(Surface)} when playing back a video will result in
+     * only the audio track being played. A null surface holder or surface will
+     * result in only the audio track being played.
+     * 
      * @param sh the SurfaceHolder to use for video display
      */
     public void setDisplay(SurfaceHolder sh) {
@@ -692,20 +755,19 @@
     /**
      * Sets the {@link Surface} to be used as the sink for the video portion of
      * the media. This is similar to {@link #setDisplay(SurfaceHolder)}, but
-     * does not support {@link #setScreenOnWhilePlaying(boolean)}.  Setting a
+     * does not support {@link #setScreenOnWhilePlaying(boolean)}. Setting a
      * Surface will un-set any Surface or SurfaceHolder that was previously set.
-     * A null surface will result in only the audio track being played.
-     *
-     * If the Surface sends frames to a {@link SurfaceTexture}, the timestamps
-     * returned from {@link SurfaceTexture#getTimestamp()} will have an
-     * unspecified zero point.  These timestamps cannot be directly compared
-     * between different media sources, different instances of the same media
-     * source, or multiple runs of the same program.  The timestamp is normally
-     * monotonically increasing and is unaffected by time-of-day adjustments,
-     * but it is reset when the position is set.
-     *
+     * A null surface will result in only the audio track being played. If the
+     * Surface sends frames to a {@link SurfaceTexture}, the timestamps returned
+     * from {@link SurfaceTexture#getTimestamp()} will have an unspecified zero
+     * point. These timestamps cannot be directly compared between different
+     * media sources, different instances of the same media source, or multiple
+     * runs of the same program. The timestamp is normally monotonically
+     * increasing and is unaffected by time-of-day adjustments, but it is reset
+     * when the position is set.
+     * 
      * @param surface The {@link Surface} to be used for the video portion of
-     * the media.
+     *            the media.
      */
     public void setSurface(Surface surface) {
         if (mScreenOnWhilePlaying && surface != null) {
@@ -716,43 +778,45 @@
         updateSurfaceScreenOn();
     }
 
-    /* Do not change these video scaling mode values below without updating
+    /*
+     * Do not change these video scaling mode values below without updating
      * their counterparts in system/window.h! Please do not forget to update
-     * {@link #isVideoScalingModeSupported} when new video scaling modes
-     * are added.
+     * {@link #isVideoScalingModeSupported} when new video scaling modes are
+     * added.
      */
     /**
-     * Specifies a video scaling mode. The content is stretched to the
-     * surface rendering area. When the surface has the same aspect ratio
-     * as the content, the aspect ratio of the content is maintained;
-     * otherwise, the aspect ratio of the content is not maintained when video
-     * is being rendered. Unlike {@link #VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING},
+     * Specifies a video scaling mode. The content is stretched to the surface
+     * rendering area. When the surface has the same aspect ratio as the
+     * content, the aspect ratio of the content is maintained; otherwise, the
+     * aspect ratio of the content is not maintained when video is being
+     * rendered. Unlike {@link #VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING},
      * there is no content cropping with this video scaling mode.
      */
     public static final int VIDEO_SCALING_MODE_SCALE_TO_FIT = 1;
 
     /**
-     * Specifies a video scaling mode. The content is scaled, maintaining
-     * its aspect ratio. The whole surface area is always used. When the
-     * aspect ratio of the content is the same as the surface, no content
-     * is cropped; otherwise, content is cropped to fit the surface.
+     * Specifies a video scaling mode. The content is scaled, maintaining its
+     * aspect ratio. The whole surface area is always used. When the aspect
+     * ratio of the content is the same as the surface, no content is cropped;
+     * otherwise, content is cropped to fit the surface.
      */
     public static final int VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING = 2;
+
     /**
-     * Sets video scaling mode. To make the target video scaling mode
-     * effective during playback, this method must be called after
-     * data source is set. If not called, the default video
-     * scaling mode is {@link #VIDEO_SCALING_MODE_SCALE_TO_FIT}.
-     *
-     * <p> The supported video scaling modes are:
+     * Sets video scaling mode. To make the target video scaling mode effective
+     * during playback, this method must be called after data source is set. If
+     * not called, the default video scaling mode is
+     * {@link #VIDEO_SCALING_MODE_SCALE_TO_FIT}.
+     * <p>
+     * The supported video scaling modes are:
      * <ul>
      * <li> {@link #VIDEO_SCALING_MODE_SCALE_TO_FIT}
      * <li> {@link #VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING}
      * </ul>
-     *
-     * @param mode target video scaling mode. Most be one of the supported
-     * video scaling modes; otherwise, IllegalArgumentException will be thrown.
-     *
+     * 
+     * @param mode target video scaling mode. Most be one of the supported video
+     *            scaling modes; otherwise, IllegalArgumentException will be
+     *            thrown.
      * @see MediaPlayer#VIDEO_SCALING_MODE_SCALE_TO_FIT
      * @see MediaPlayer#VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING
      */
@@ -775,27 +839,33 @@
     }
 
     /**
-     * Convenience method to create a MediaPlayer for a given Uri.
-     * On success, {@link #prepare()} will already have been called and must not be called again.
-     * <p>When done with the MediaPlayer, you should call  {@link #release()},
-     * to free the resources. If not released, too many MediaPlayer instances will
-     * result in an exception.</p>
-     *
+     * Convenience method to create a MediaPlayer for a given Uri. On success,
+     * {@link #prepare()} will already have been called and must not be called
+     * again.
+     * <p>
+     * When done with the MediaPlayer, you should call {@link #release()}, to
+     * free the resources. If not released, too many MediaPlayer instances will
+     * result in an exception.
+     * </p>
+     * 
      * @param context the Context to use
      * @param uri the Uri from which to get the datasource
      * @return a MediaPlayer object, or null if creation failed
      */
     public static MediaPlayer create(Context context, Uri uri) {
-        return create (context, uri, null);
+        return create(context, uri, null);
     }
 
     /**
-     * Convenience method to create a MediaPlayer for a given Uri.
-     * On success, {@link #prepare()} will already have been called and must not be called again.
-     * <p>When done with the MediaPlayer, you should call  {@link #release()},
-     * to free the resources. If not released, too many MediaPlayer instances will
-     * result in an exception.</p>
-     *
+     * Convenience method to create a MediaPlayer for a given Uri. On success,
+     * {@link #prepare()} will already have been called and must not be called
+     * again.
+     * <p>
+     * When done with the MediaPlayer, you should call {@link #release()}, to
+     * free the resources. If not released, too many MediaPlayer instances will
+     * result in an exception.
+     * </p>
+     * 
      * @param context the Context to use
      * @param uri the Uri from which to get the datasource
      * @param holder the SurfaceHolder to use for displaying the video
@@ -825,24 +895,29 @@
         return null;
     }
 
-    // Note no convenience method to create a MediaPlayer with SurfaceTexture sink.
+    // Note no convenience method to create a MediaPlayer with SurfaceTexture
+    // sink.
 
     /**
-     * Convenience method to create a MediaPlayer for a given resource id.
-     * On success, {@link #prepare()} will already have been called and must not be called again.
-     * <p>When done with the MediaPlayer, you should call  {@link #release()},
-     * to free the resources. If not released, too many MediaPlayer instances will
-     * result in an exception.</p>
-     *
+     * Convenience method to create a MediaPlayer for a given resource id. On
+     * success, {@link #prepare()} will already have been called and must not be
+     * called again.
+     * <p>
+     * When done with the MediaPlayer, you should call {@link #release()}, to
+     * free the resources. If not released, too many MediaPlayer instances will
+     * result in an exception.
+     * </p>
+     * 
      * @param context the Context to use
      * @param resid the raw resource id (<var>R.raw.&lt;something></var>) for
-     *              the resource to use as the datasource
+     *            the resource to use as the datasource
      * @return a MediaPlayer object, or null if creation failed
      */
     public static MediaPlayer create(Context context, int resid) {
         try {
             AssetFileDescriptor afd = context.getResources().openRawResourceFd(resid);
-            if (afd == null) return null;
+            if (afd == null)
+                return null;
 
             MediaPlayer mp = new MediaPlayer();
             mp.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
@@ -854,7 +929,7 @@
             // fall through
         } catch (IllegalArgumentException ex) {
             Log.d(TAG, "create failed:", ex);
-           // fall through
+            // fall through
         } catch (SecurityException ex) {
             Log.d(TAG, "create failed:", ex);
             // fall through
@@ -864,38 +939,58 @@
 
     /**
      * Sets the data source as a content Uri.
-     *
+     * 
      * @param context the Context to use when resolving the Uri
      * @param uri the Content URI of the data you want to play
      * @throws IllegalStateException if it is called in an invalid state
      */
     public void setDataSource(Context context, Uri uri)
-        throws IOException, IllegalArgumentException, SecurityException, IllegalStateException {
+            throws IOException, IllegalArgumentException, SecurityException, IllegalStateException {
+        Log.d(TAG, "111 - hc");
         setDataSource(context, uri, null);
     }
 
+    public void setDataSource(Context context, Uri uri, boolean toRemote)
+            throws IOException, IllegalArgumentException, SecurityException, IllegalStateException {
+        Log.d(TAG, "888 - hc");
+        
+        setDataSource(context, uri, null);
+    }
+    
     /**
      * Sets the data source as a content Uri.
-     *
+     * 
      * @param context the Context to use when resolving the Uri
      * @param uri the Content URI of the data you want to play
-     * @param headers the headers to be sent together with the request for the data
+     * @param headers the headers to be sent together with the request for the
+     *            data
      * @throws IllegalStateException if it is called in an invalid state
      */
     public void setDataSource(Context context, Uri uri, Map<String, String> headers)
-        throws IOException, IllegalArgumentException, SecurityException, IllegalStateException {
+            throws IOException, IllegalArgumentException, SecurityException, IllegalStateException {
+        Log.d(TAG, "222 - hc");
         disableProxyListener();
 
         String scheme = uri.getScheme();
-        if(scheme == null || scheme.equals("file")) {
+        if (scheme == null || scheme.equals("file")) {
             setDataSource(uri.getPath());
             return;
         }
-
+        
         AssetFileDescriptor fd = null;
         try {
             ContentResolver resolver = context.getContentResolver();
             fd = resolver.openAssetFileDescriptor(uri, "r");
+            Log.d(TAG, "hc : " + uri.toString());
+            mContext = context;
+            mContent = uri;
+            if (uri.toString().contains("audio")) {
+                isAudio = true;
+                Log.d(TAG, "hc : audio true (should be true), " + isAudio);
+            } else {
+                isAudio = false;
+                Log.d(TAG, "hc : video true (should be false), " + isAudio);
+            }
             if (fd == null) {
                 return;
             }
@@ -904,6 +999,7 @@
             // a full file.
             if (fd.getDeclaredLength() < 0) {
                 setDataSource(fd.getFileDescriptor());
+
             } else {
                 setDataSource(fd.getFileDescriptor(), fd.getStartOffset(), fd.getDeclaredLength());
             }
@@ -911,9 +1007,9 @@
         } catch (SecurityException ex) {
         } catch (IOException ex) {
         } finally {
-            if (fd != null) {
-                fd.close();
-            }
+//            if (fd != null) {
+//                fd.close();
+//            }
         }
 
         Log.d(TAG, "Couldn't open file on client side, trying server side");
@@ -928,33 +1024,139 @@
 
     /**
      * Sets the data source (file-path or http/rtsp URL) to use.
-     *
-     * @param path the path of the file, or the http/rtsp URL of the stream you want to play
+     * 
+     * @param path the path of the file, or the http/rtsp URL of the stream you
+     *            want to play
      * @throws IllegalStateException if it is called in an invalid state
-     *
-     * <p>When <code>path</code> refers to a local file, the file may actually be opened by a
-     * process other than the calling application.  This implies that the pathname
-     * should be an absolute path (as any other process runs with unspecified current working
-     * directory), and that the pathname should reference a world-readable file.
-     * As an alternative, the application could first open the file for reading,
-     * and then use the file descriptor form {@link #setDataSource(FileDescriptor)}.
-     */
-    public void setDataSource(String path)
-            throws IOException, IllegalArgumentException, SecurityException, IllegalStateException {
+     *             <p>
+     *             When <code>path</code> refers to a local file, the file may
+     *             actually be opened by a process other than the calling
+     *             application. This implies that the pathname should be an
+     *             absolute path (as any other process runs with unspecified
+     *             current working directory), and that the pathname should
+     *             reference a world-readable file. As an alternative, the
+     *             application could first open the file for reading, and then
+     *             use the file descriptor form
+     *             {@link #setDataSource(FileDescriptor)}.
+     */
+
+    public void setDataSource(String path) throws IOException,
+            IllegalArgumentException, SecurityException, IllegalStateException {
+        Log.d(TAG, "333 - hc");
+        /*if (path.substring(path.length() - 3, path.length()).equalsIgnoreCase("mp3")) {
+            // extractor setting
+            MediaExtractor extractor;
+            extractor = new MediaExtractor();
+            try {
+                extractor.setDataSource(path);
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            // format setting
+            MediaFormat format = null;
+            String mime = "";
+            int sampleRate = 0, channels = 0, bitrate = 0;
+            long duration = 0;
+            byte[] buffer = new byte[627];
+            try {
+                format = extractor.getTrackFormat(0);
+                mime = format.getString(MediaFormat.KEY_MIME);
+                sampleRate = format.getInteger(MediaFormat.KEY_SAMPLE_RATE);
+                channels = format.getInteger(MediaFormat.KEY_CHANNEL_COUNT);
+                // if duration is 0, we are probably playing a live stream
+                duration = format.getLong(MediaFormat.KEY_DURATION);
+                bitrate = format.getInteger(MediaFormat.KEY_BIT_RATE);
+            } catch (Exception e) {
+                Log.e(TAG, "Reading format parameters exception:" + e.getMessage());
+                // don't exit, tolerate this error, we'll fail later if this is
+                // critical
+            }
+            extractor.selectTrack(0);
+
+            // check the format variables
+            Log.d(TAG, "Track info: mime:" + mime + " sampleRate:" + sampleRate
+                    + " channels:" + channels + " bitrate:" + bitrate
+                    + " duration:" + duration);
+            // mService = IRemoteRequestHandler.Stub.asInterface(ServiceManager
+            // .getService(Context.REMOTE_SERVICE));
+            RemoteRequestManager mService = new RemoteRequestManager();
+            ArrayList<Object> parameters = new ArrayList<Object>();
+            parameters.add(0, mime);
+            parameters.add(1, sampleRate);
+            parameters.add(2, channels);
+            parameters.add(3, duration);
+            RemoteRequest mRequest = new RemoteRequest("RemoteMusic", "SettingCodec", parameters);
+
+            mService.sendRequest(mRequest);
+            parameters.clear();
+
+            // feeding
+            ByteBuffer tmp_byteBuffer = null;
+            int sampleSize = 0;
+            boolean flag = true;
+            // try {
+            while (flag) {
+                tmp_byteBuffer = ByteBuffer.wrap(buffer);
+                sampleSize = extractor.readSampleData(tmp_byteBuffer, 0);
+                byte[] to_send = new byte[sampleSize];
+                for (int i = 0; i < to_send.length; i++) {
+                    to_send[i] = tmp_byteBuffer.get(i);
+                }
+                long presentationTime = extractor.getSampleTime();
+
+                mService.sendMusicData(sampleSize, to_send, presentationTime);
+                if (sampleSize <= 0) {
+                    // this is where music file is ended
+                } else {
+                    extractor.advance();
+                }
+                // Log.d(TAG, "File: i sent" + Arrays.toString(to_send));
+                // Thread.sleep(1000);
+            }
+            // } catch (RemoteException e) {
+            // // TODO Auto-generated catch block
+            // e.printStackTrace();
+            // }
+            // Stopping music
+            mRequest = new RemoteRequest("StopMusic", null, null);
+            // try {
+            mService.sendRequest(mRequest);
+            // } catch (RemoteException e) {
+            // // TODO Auto-generated catch block
+            // e.printStackTrace();
+            // } finally{
+            parameters.clear();
+            // }
+
+        }
+        // video
+        else {
+//            RemoteRequestManager mService = new RemoteRequestManager();
+//            RemoteRequest mRequest = new RemoteRequest("video_streaming", "get surface", null);
+//            mService.sendRequest(mRequest);
+////            mVideoFeeder video = new mVideoFeeder(path, 8888);
+////            video.start();
+        }*/
+
         setDataSource(path, null, null);
     }
 
     /**
      * Sets the data source (file-path or http/rtsp URL) to use.
-     *
-     * @param path the path of the file, or the http/rtsp URL of the stream you want to play
-     * @param headers the headers associated with the http request for the stream you want to play
+     * 
+     * @param path the path of the file, or the http/rtsp URL of the stream you
+     *            want to play
+     * @param headers the headers associated with the http request for the
+     *            stream you want to play
      * @throws IllegalStateException if it is called in an invalid state
      * @hide pending API council
      */
     public void setDataSource(String path, Map<String, String> headers)
             throws IOException, IllegalArgumentException, SecurityException, IllegalStateException
     {
+        Log.d(TAG, "444 - hc");
         String[] keys = null;
         String[] values = null;
 
@@ -963,7 +1165,7 @@
             values = new String[headers.size()];
 
             int i = 0;
-            for (Map.Entry<String, String> entry: headers.entrySet()) {
+            for (Map.Entry<String, String> entry : headers.entrySet()) {
                 keys[i] = entry.getKey();
                 values[i] = entry.getValue();
                 ++i;
@@ -974,6 +1176,7 @@
 
     private void setDataSource(String path, String[] keys, String[] values)
             throws IOException, IllegalArgumentException, SecurityException, IllegalStateException {
+        Log.d(TAG, "555 - hc");
         disableProxyListener();
 
         final Uri uri = Uri.parse(path);
@@ -982,6 +1185,7 @@
         }
 
         final File file = new File(path);
+
         if (file.exists()) {
             FileInputStream is = new FileInputStream(file);
             FileDescriptor fd = is.getFD();
